<?php
/**
 * Plugin Name: Benchmark Utilities
 * Plugin URI: http://e-merald.com/plugins/benchmark/
 * Description: Utilities for the Benchmark WordPress theme: 1) Displaying the social share buttons in a single post, 2) Processing the data received from a contact/subscription form and sending the email message.
 * Version: 1.1
 * Author: emerald
 * Author URI: http://e-merald.com
 * License: GPL-2.0+
 */

if ( ! defined( 'WPINC' ) ) {
	die;
}


/**
 * Register the theme's widgets.
 *
 * @since 1.1
 */

if ( ! function_exists( 'benchmark_widgets_register' ) ) {
	
	function benchmark_widgets_register() {
		
		if ( class_exists( 'Benchmark_Accordion_Widget' ) ) {
			register_widget( 'Benchmark_Accordion_Widget' );          // Accordion
		}
		if ( class_exists( 'Benchmark_Banner_Widget' ) ) {
			register_widget( 'Benchmark_Banner_Widget' );             // Banner
		}
		if ( class_exists( 'Benchmark_Blog_Widget' ) ) {
			register_widget( 'Benchmark_Blog_Widget' );               // Blog
		}
		if ( class_exists( 'Benchmark_Contact_Form_Widget' ) ) {
			register_widget( 'Benchmark_Contact_Form_Widget' );       // Contact Form
		}
		if ( class_exists( 'Benchmark_Divider_Widget' ) ) {
			register_widget( 'Benchmark_Divider_Widget' );            // Divider
		}
		if ( class_exists( 'Benchmark_Dot_Leaders_Widget' ) ) {
			register_widget( 'Benchmark_Dot_Leaders_Widget' );        // Dot Leaders
		}
		if ( class_exists( 'Benchmark_Featured_Article_Widget' ) ) {
			register_widget( 'Benchmark_Featured_Article_Widget' );   // Featured Article
		}
		if ( class_exists( 'Benchmark_Feature_List_Widget' ) ) {
			register_widget( 'Benchmark_Feature_List_Widget' );       // Feature List
		}
		if ( class_exists( 'Benchmark_Flickr_Photostream_Widget' ) ) {
			register_widget( 'Benchmark_Flickr_Photostream_Widget' ); // Flickr Photostream
		}
		if ( class_exists( 'Benchmark_Gallery_Widget' ) ) {
			register_widget( 'Benchmark_Gallery_Widget' );            // Gallery
		}
		if ( class_exists( 'Benchmark_Google_Maps_Widget' ) ) {
			register_widget( 'Benchmark_Google_Maps_Widget' );        // Google Maps
		}
		if ( class_exists( 'Benchmark_Icon_Boxes_Widget' ) ) {
			register_widget( 'Benchmark_Icon_Boxes_Widget' );         // Icon Boxes
		}
		if ( class_exists( 'Benchmark_Icon_Carousel_Widget' ) ) {
			register_widget( 'Benchmark_Icon_Carousel_Widget' );      // Icon Carousel
		}
		if ( class_exists( 'Benchmark_Image_Carousel_Widget' ) ) {
			register_widget( 'Benchmark_Image_Carousel_Widget' );     // Image Carousel
		}
		if ( class_exists( 'Benchmark_Image_Grid_Widget' ) ) {
			register_widget( 'Benchmark_Image_Grid_Widget' );         // Image Grid
		}
		if ( class_exists( 'Benchmark_Image_Slider_Widget' ) ) {
			register_widget( 'Benchmark_Image_Slider_Widget' );       // Image Slider
		}
		if ( class_exists( 'Benchmark_Info_Box_Widget' ) ) {
			register_widget( 'Benchmark_Info_Box_Widget' );           // Info Box
		}
		if ( class_exists( 'Benchmark_News_Widget' ) ) {
			register_widget( 'Benchmark_News_Widget' );               // News
		}
		if ( class_exists( 'Benchmark_Picture_Boxes_Widget' ) ) {
			register_widget( 'Benchmark_Picture_Boxes_Widget' );      // Picture Boxes widget
		}
		if ( class_exists( 'Benchmark_Pricing_Table_Widget' ) ) {
			register_widget( 'Benchmark_Pricing_Table_Widget' );      // Pricing Table
		}
		if ( class_exists( 'Benchmark_Pullquote_Widget' ) ) {
			register_widget( 'Benchmark_Pullquote_Widget' );          // Pullquote
		}
		if ( class_exists( 'Benchmark_Services_Widget' ) ) {
			register_widget( 'Benchmark_Services_Widget' );           // Services
		}
		if ( class_exists( 'Benchmark_Single_Image_Widget' ) ) {
			register_widget( 'Benchmark_Single_Image_Widget' );       // Single Image
		}
		if ( class_exists( 'Benchmark_Social_Profiles_Widget' ) ) {
			register_widget( 'Benchmark_Social_Profiles_Widget' );    // Social Profiles
		}
		if ( class_exists( 'Benchmark_Split_Sections_Widget' ) ) {
			register_widget( 'Benchmark_Split_Sections_Widget' );     // Split Sections
		}
		if ( class_exists( 'Benchmark_Staff_Widget' ) ) {
			register_widget( 'Benchmark_Staff_Widget' );              // Staff
		}
		if ( class_exists( 'Benchmark_Stages_Widget' ) ) {
			register_widget( 'Benchmark_Stages_Widget' );             // Stages
		}
		if ( class_exists( 'Benchmark_Standard_Table_Widget' ) ) {
			register_widget( 'Benchmark_Standard_Table_Widget' );     // Standard Table
		}
		if ( class_exists( 'Benchmark_Stat_Data_Widget' ) ) {
			register_widget( 'Benchmark_Stat_Data_Widget' );          // Stat Data
		}
		if ( class_exists( 'Benchmark_Subscription_Form_Widget' ) ) {
			register_widget( 'Benchmark_Subscription_Form_Widget' );  // Subscription Form
		}
		if ( class_exists( 'Benchmark_Tabs_Widget' ) ) {
			register_widget( 'Benchmark_Tabs_Widget' );               // Tabs
		}
		if ( class_exists( 'Benchmark_Tabs_Fullwidth_Widget' ) ) {
			register_widget( 'Benchmark_Tabs_Fullwidth_Widget' );     // Full-width Tabs
		}
		if ( class_exists( 'Benchmark_Testimonials_Widget' ) ) {
			register_widget( 'Benchmark_Testimonials_Widget' );       // Testimonials
		}
		if ( class_exists( 'Benchmark_Text_Block_Widget' ) ) {
			register_widget( 'Benchmark_Text_Block_Widget' );         // Text Block
		}
		if ( class_exists( 'Benchmark_Twitter_Feed_Widget' ) ) {
			register_widget( 'Benchmark_Twitter_Feed_Widget' );       // Twitter Feed
		}
		if ( class_exists( 'Benchmark_Venn_Diagram_Widget' ) ) {
			register_widget( 'Benchmark_Venn_Diagram_Widget' );       // Venn Diagram
		}
		if ( class_exists( 'Benchmark_Video_Widget' ) ) {
			register_widget( 'Benchmark_Video_Widget' );              // Video
		}
		if ( class_exists( 'Benchmark_Works_Widget' ) ) {
			register_widget( 'Benchmark_Works_Widget' );              // Works
		}
		
	}
	
}
add_action( 'widgets_init', 'benchmark_widgets_register', 11 );


/**
 * Display the social sharing section (social share buttons) in a single post.
 *
 * @since 1.0
 */
function benchmark_post_share_buttons( $title, $label ) {
	$benchmark_options = get_option( 'benchmark_options' );
	$social_networks = $benchmark_options['social-share-networks'];
	if ( ! is_array( $social_networks ) ) {
		return;
	}
	$array_vals = array_values( $social_networks );

	if ( in_array( '1', $array_vals ) ) { ?>
	
		<!-- Post Share -->
		<div class="post-share">
			<h6 class="title">
				<?php
				echo $title;
				echo is_singular( 'post' ) ? '<span> ' . $label . '</span>' : '';
				?>
			</h6>
			<ul class="fa-icon-list social-share clearfix">
				
		<?php foreach ( $social_networks as $key => $value ) {
			
			// LinkedIn
			if ( $key == 'linkedin' && $value ) { ?>
				<li class="linkedin">
					<a href="http://www.linkedin.com/shareArticle?mini=true&url=<?php echo esc_url( get_permalink() ); ?>&title=<?php echo esc_attr( urlencode( get_the_title() ) ); ?>" title="LinkedIn" target="_blank"><i class="fa fa-fw fa-linkedin"></i></a>
				</li>
			<?php }
			
			// Twitter
			if ( $key == 'twitter' && $value ) { ?>
				<li class="twitter">
					<a href="https://twitter.com/intent/tweet?url=<?php echo esc_url( get_permalink() ); ?>&text=<?php echo esc_attr( urlencode( get_the_title() ) ); ?>" title="Twitter" target="_blank"><i class="fa fa-fw fa-twitter"></i></a>
				</li>
			<?php }
			
			// Facebook
			if ( $key == 'facebook' && $value ) { ?>
				<li class="facebook">
					<a href="https://www.facebook.com/sharer/sharer.php?u=<?php echo esc_url( get_permalink() ); ?>" title="Facebook" target="_blank"><i class="fa fa-fw fa-facebook"></i></a>
				</li>
			<?php }
				
			// Pinterest
			if ( $key == 'pinterest' && $value ) { ?>
				<li class="pinterest">
					<a href="http://pinterest.com/pin/create/button/?url=<?php echo esc_url( get_permalink() ); ?>&media=&description=<?php echo esc_attr( urlencode( get_the_title() ) ); ?>" title="Pinterest" target="_blank"><i class="fa fa-fw fa-pinterest-p"></i></a>
				</li>
			<?php }
			
			// Google Plus
			if ( $key == 'google-plus' && $value ) { ?>
				<li class="google">
					<a href="https://plus.google.com/share?url=<?php echo esc_url( get_permalink() ); ?>" title="Google+" target="_blank"><i class="fa fa-fw fa-google-plus"></i></a>
				</li>
			<?php }
			
		} ?>
			
			</ul>
		</div>
	<?php
	}
}


/**
 * AJAX front end: Process data received from a contact form and send email message.
 *
 * @since 1.0
 */

function benchmark_process_contact_form_data() {
	global $benchmark_config;
	
	$sender_email = '';
	
	if ( isset( $_POST['author'] ) && empty( $_POST['sender-name'] ) && wp_verify_nonce( $_POST['_benchmark_nonce_cf'], 'cf_nonce_act' ) ) {
		// "sender-name" - hidden field to prevent bot spam
		// "_benchmark_nonce_cf" - hidden "nonce" field
		
		// Calculate the message sending time (local time)
		if ( isset( $_POST['timezone_offset'] ) ) {
			$timezone_offset = $_POST['timezone_offset']; // time difference between UTC time and sender local time, in minutes
		} else {
			$timezone_offset = 0;
		}
		$local_unixtime = mktime( date("H"), date("i")-$timezone_offset, date("s")-date("Z"), date("m") , date("d"), date("Y") );
		$tz_offset_in_hours = round( $timezone_offset/60 );
		$utc = $timezone_offset > 0 ? -$tz_offset_in_hours : '+' . abs( $tz_offset_in_hours );
		$local_date = date( 'm/d/Y H:i:s', $local_unixtime ) . ' (UTC' .$utc. ')'; // for example: UTC+2, UTC+0, UTC-7
		
		// Content
		$content = $local_date . "\n\n";
		if ( ! empty( $_POST['author'] ) ) {  // name
			$content .= $benchmark_config['form-labels']['name_label'] . ': ' . sanitize_text_field( $_POST['author'] ) . "\n";
		}
		if ( ! empty( $_POST['email'] ) ) {   // email
			$content .= $benchmark_config['form-labels']['email_label'] . ': ' . sanitize_email( $_POST['email'] ) . "\n";
			$sender_email = $_POST['email'];
		}
		if ( ! empty( $_POST['phone'] ) ) {   // phone
			$content .= $benchmark_config['form-labels']['phone_label'] . ': ' . sanitize_text_field( $_POST['phone'] ) . "\n";
		}
		if ( ! empty( $_POST['website'] ) ) { // website
			$content .= $benchmark_config['form-labels']['website_label'] . ': ' . sanitize_text_field( $_POST['website'] ) . "\n";
		}
		if ( ! empty( $_POST['custom1'] ) && ! empty( $_POST['custom1_label'] ) ) { // custom 1
			$content .= $_POST['custom1_label'] . ': ' . sanitize_text_field( $_POST['custom1'] ) . "\n";
		}
		if ( ! empty( $_POST['custom2'] ) && ! empty( $_POST['custom2_label'] ) ) { // custom 2
			$content .= $_POST['custom2_label'] . ': ' . sanitize_text_field( $_POST['custom2'] ) . "\n";
		}
		if ( ! empty( $_POST['custom3'] ) && ! empty( $_POST['custom3_label'] ) ) { // custom 3
			$content .= $_POST['custom3_label'] . ': ' . sanitize_text_field( $_POST['custom3'] ) . "\n";
		}
		if ( ! empty( $_POST['subject'] ) ) { // subject
			$content .= $benchmark_config['form-labels']['subject_label'] . ': ' . $_POST['subject'] . "\n";
		}
		if ( ! empty( $_POST['message'] ) ) { // text
			$content .= "\n" . wp_kses_data( $_POST['message'] );
		}
		
		$headers = "MIME-Version: 1.0\r\n";
		$headers .= "Content-Type: text/plain; charset=UTF-8\r\n";
		$headers .= "X-Mailer: PHP/" . phpversion();
		
		// Contact Form widget or Contact Form in the footer:
		// benchmark_enqueue_scripts function -> custom.js -> AJAX -> benchmark_process_contact_form_data function
		$recipient_email = isset( $_POST['recipient_email'] ) ? $_POST['recipient_email'] : '';
		$email_subject = isset( $_POST['email_subject'] ) ? $_POST['email_subject'] : sprintf( '[%s] %s', get_option( 'blogname' ), $benchmark_config['email-subject']['contact'] );
		
		// Send email message
		if ( $recipient_email && wp_mail( $recipient_email, $email_subject, $content, $headers ) ) {
			echo 'success';
		} else {
			echo 'error';
		}
	}
	
	die();
}

if ( is_admin() ) { // front-end Ajax hooks must be inside "is_admin" part
	add_action( 'wp_ajax_benchmark_process_contact_form_data', 'benchmark_process_contact_form_data' );
	add_action( 'wp_ajax_nopriv_benchmark_process_contact_form_data', 'benchmark_process_contact_form_data' );
}


/**
 * AJAX front end: Process data received from a subscription form and send email message.
 *
 * @since 1.0
 */

if ( ! function_exists( 'benchmark_process_subscription_form_data' ) ) {
	
	function benchmark_process_subscription_form_data() {
		global $benchmark_config;
		
		$benchmark_options = get_option( 'benchmark_options' );
		$sender_email = '';
		
		if ( ! empty( $_POST['subscriber_email'] ) && empty( $_POST['sender-name'] ) && wp_verify_nonce( $_POST['_benchmark_nonce_sf'], 'sf_nonce_act' ) ) {
			// "sender-name" - hidden field to prevent bot spam
			// "_benchmark_nonce_sf" - hidden "nonce" field
			
			// Calculate the message sending time (local time)
			if ( isset( $_POST['timezone_offset'] ) ) {
				$timezone_offset = $_POST['timezone_offset']; // time difference between UTC time and sender local time, in minutes
			} else {
				$timezone_offset = 0;
			}
			$local_unixtime = mktime( date("H"), date("i")-$timezone_offset, date("s")-date("Z"), date("m") , date("d"), date("Y") );
			$tz_offset_in_hours = round( $timezone_offset/60 );
			$utc = $timezone_offset > 0 ? -$tz_offset_in_hours : '+' . abs( $tz_offset_in_hours );
			$local_date = date( 'm/d/Y H:i:s', $local_unixtime ) . ' (UTC' .$utc. ')'; // for example: UTC+2, UTC+0, UTC-7
			
			// Content
			$content = $local_date . "\n\n";
			if ( ! empty( $_POST['subscriber_name'] ) ) {  // name
				$content .= $benchmark_config['form-labels']['name_label'] . ': ' . sanitize_text_field( $_POST['subscriber_name'] ) . "\n";
			}
			if ( ! empty( $_POST['subscriber_email'] ) ) { // email
				$content .= $benchmark_config['form-labels']['subscriber_email_label'] . ': ' . sanitize_email( $_POST['subscriber_email'] ) . "\n";
				$sender_email = $_POST['subscriber_email'];
			}
			
			$headers = "MIME-Version: 1.0\r\n";
			$headers .= "Content-Type: text/plain; charset=UTF-8\r\n";
			$headers .= "X-Mailer: PHP/" . phpversion();
			
			$recipient_email = ! empty( $benchmark_options['sform-recipient-email'] ) ? $benchmark_options['sform-recipient-email'] : '';
			$email_subject = ! empty( $benchmark_options['sform-email-subject'] ) ? $benchmark_options['sform-email-subject'] : sprintf( '[%s] %s', get_option( 'blogname' ), $benchmark_config['email-subject']['subscription'] );
			
			// Send email message
			if ( $recipient_email && wp_mail( $recipient_email, $email_subject, $content, $headers ) ) {
				echo 'success';
			} else {
				echo 'error';
			}
		}
		
		die();
	}
	
}

if ( is_admin() ) { // front-end Ajax hooks must be inside "is_admin" part
	add_action( 'wp_ajax_benchmark_process_subscription_form_data', 'benchmark_process_subscription_form_data' );
	add_action( 'wp_ajax_nopriv_benchmark_process_subscription_form_data', 'benchmark_process_subscription_form_data' );
}